proc OneDHistogram {instvars} {
  global colour_options colour_label line_options line_label oneDHist
  set oneDHist .alterOneDHistogram
  array set instarray $instvars
  catch {destroy $oneDHist}
  toplevel $oneDHist
  wm title $oneDHist "Alter Histogram"

  set colour $instarray(colour)
  set linetype $instarray(type)
  set thickness $instarray(lineThickness)
  set centred $instarray(binCentre)

  tixOptionMenu $oneDHist.colour -label "Colour" -variable colour
  foreach opt $colour_options {
    $oneDHist.colour add command $opt -label $colour_label($opt)
  }

  tixOptionMenu $oneDHist.linetype -label "Line Type" -variable linetype
  foreach opt $line_options {
    $oneDHist.linetype add command $opt -label $line_label($opt)
  }

  $oneDHist.colour config -value $colour
  $oneDHist.linetype config -value $linetype

  frame $oneDHist.top
  pack $oneDHist.top

  foreach type {centred notCentred} {
    radiobutton $oneDHist.top.$type -text $type -variable centred -value $type
    pack $oneDHist.top.$type -side left -expand yes -fill x
  }
  $oneDHist.top.notCentred select

  tixLabelEntry $oneDHist.thickness -label "Line Thickness" -labelside left
  $oneDHist.thickness subwidget entry config -textvariable thickness

  tixButtonBox $oneDHist.box -orientation horizontal
  $oneDHist.box add ok -text Ok -command "drawOneDHist {$instvars}"
  $oneDHist.box add cancel -text Cancel -command "catch {destroy $oneDHist}"

  pack $oneDHist.colour $oneDHist.linetype $oneDHist.thickness \
       $oneDHist.box -side top -expand yes -fill x
}

proc drawOneDHist {instvars} {
  global colour centred thickness oneDHist linetype
  array set instarray $instvars

  set thickness [string trim $thickness]
  if {[string len $thickness] == 0} {
    set thickness $instarray(lineThickness)
  }

  if {[string match $centred 1] == 1} {
    set centred 1
  } else {
    set centred 0
  }

# It seem to be neccessary to go through all of this code, to get the correct
# object and picture number.  Any other way seems to work ONLY for single
# digits !!

  set objectid $instarray(objid)
  set tmp [string trim $objectid {] Array (2)} ]
  set tmp [string trim $tmp {[} ]
  set num [string wordend $tmp 0]
  set object [string range $tmp 0 $num]
  set picture [expr [string range $tmp [expr $num + 1] [string len $tmp] ] + 1]

  set output [smalltalk "|tmp temp|
	     tmp _ ((gXUUgraphics at: #gXcurrentgraphics) alterTCL: $object
		     and: $picture with: '$objectid').
	     (tmp isNil)
	     ifFalse:\[temp _ (tmp colour: $colour; lineThickness: $thickness;
			       type: $linetype; binCentre: $centred; create).
	     			((gXUUgraphics at: #gXcurrentdevice) Clear).
	  	((gXUUgraphics at: #gXcurrentgraphics) drawPicture: $picture)\]

	     ifTrue:\['OneDHistogram has not been altered' prinl\] !"]

	     
  testOutput $output
  destroy $oneDHist
}
